unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: Jani Nikula <jani@nikula.org>
To: notmuch@notmuchmail.org
Subject: [PATCH 1/8] completion: complete notmuch emacs-mua
Date: Thu,  3 Nov 2016 22:37:54 +0200	[thread overview]
Message-ID: <9bac5b368e394a2437e325564bf91db8a8f9a00d.1478205331.git.jani@nikula.org> (raw)
In-Reply-To: <cover.1478205331.git.jani@nikula.org>
In-Reply-To: <cover.1478205331.git.jani@nikula.org>

With subcommand handling for external commands we can easily complete
'notmuch emacs-mua' using the existing completion system.
---
 completion/notmuch-completion.bash | 34 +++++++++++++++++++++++++++++++++-
 1 file changed, 33 insertions(+), 1 deletion(-)

diff --git a/completion/notmuch-completion.bash b/completion/notmuch-completion.bash
index 78047b5f424d..9e1f7bb74bbf 100644
--- a/completion/notmuch-completion.bash
+++ b/completion/notmuch-completion.bash
@@ -204,6 +204,38 @@ _notmuch_dump()
     esac
 }
 
+_notmuch_emacs_mua()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--to|--cc|--bcc)
+	    COMPREPLY=( $(compgen -W "`_notmuch_email to:${cur}`" -- ${cur}) )
+	    return
+	    ;;
+	--body)
+	    _filedir
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+        -*)
+	    local options="--subject= --to= --cc= --bcc= --body= --no-window-system --client --auto-daemon --create-frame --print --help"
+
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    COMPREPLY=( $(compgen -W "`_notmuch_email to:${cur}`" -- ${cur}) )
+	    return
+	    ;;
+    esac
+}
+
 _notmuch_insert()
 {
     local cur prev words cword split
@@ -464,7 +496,7 @@ _notmuch_tag()
 
 _notmuch()
 {
-    local _notmuch_commands="compact config count dump help insert new reply restore search address setup show tag"
+    local _notmuch_commands="compact config count dump help insert new reply restore search address setup show tag emacs-mua"
     local arg cur prev words cword split
 
     # require bash-completion with _init_completion
-- 
2.1.4

  reply	other threads:[~2016-11-03 20:39 UTC|newest]

Thread overview: 15+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-11-03 20:37 [PATCH 0/8] improvements around notmuch-emacs-mua Jani Nikula
2016-11-03 20:37 ` Jani Nikula [this message]
2016-11-03 20:37 ` [PATCH 2/8] man: advertize notmuch-emacs-mua as notmuch emacs-mua subcommand Jani Nikula
2016-11-03 20:37 ` [PATCH 3/8] emacs: move notmuch-emacs-mua under emacs Jani Nikula
2016-11-03 20:37 ` [PATCH 4/8] build: install notmuch-emacs-mua with notmuch-emacs Jani Nikula
2016-11-03 20:37 ` [PATCH 5/8] notmuch.desktop: move under emacs as notmuch-emacs-mua.desktop Jani Nikula
2016-11-03 20:37 ` [PATCH 6/8] emacs/desktop: update to use notmuch-emacs-mua and handle mailto Jani Nikula
2016-11-21 11:34   ` David Bremner
2016-11-21 11:44     ` Jani Nikula
2016-11-21 12:29       ` Tomi Ollila
2016-11-21 16:22       ` Keith Amidon
2016-11-21 20:49         ` Jani Nikula
2016-11-21 20:52           ` Jani Nikula
2016-11-03 20:38 ` [PATCH 7/8] build: install notmuch-emacs-mua.desktop file with emacs Jani Nikula
2016-11-03 20:38 ` [PATCH 8/8] build: update the desktop database after installing the desktop file Jani Nikula

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=9bac5b368e394a2437e325564bf91db8a8f9a00d.1478205331.git.jani@nikula.org \
    --to=jani@nikula.org \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).